#include "Battle.hpp"
void PkmnLib::Battling::Battle::SetWeather(const ArbUt::StringView& name) {
    if (_weatherScript != nullptr) {
        _weatherScript->OnRemove();
    }
    _weatherScript = std::unique_ptr<CreatureLib::Battling::Script>(
        _library->LoadScript(static_cast<ScriptCategory>(PkmnScriptCategory::Weather), name));
    _eventHook.Trigger<WeatherChangeEvent>(name);
}
void PkmnLib::Battling::Battle::ClearWeather() {
    _weatherScript->OnRemove();
    _weatherScript = nullptr;
    _eventHook.Trigger<WeatherChangeEvent>(""_cnc);
}
