#ifndef PKMNLIB_DAMAGELIBRARY_HPP
#define PKMNLIB_DAMAGELIBRARY_HPP

#include <CreatureLib/Battling/Library/DamageLibrary.hpp>
namespace PkmnLib::Battling {
    class DamageLibrary : public CreatureLib::Battling::DamageLibrary {
    public:
        uint32_t GetDamage(CreatureLib::Battling::ExecutingAttack* attack, CreatureLib::Battling::Creature* target,
                           uint8_t hitIndex,
                           const CreatureLib::Battling::ExecutingAttack::HitData& hitData) const override;

        uint8_t GetBasePower(CreatureLib::Battling::ExecutingAttack* attack, CreatureLib::Battling::Creature* target,
                             uint8_t hitIndex,
                             const CreatureLib::Battling::ExecutingAttack::HitData& hitData) const override;
        float GetStatModifier(CreatureLib::Battling::ExecutingAttack* attack, CreatureLib::Battling::Creature* target,
                              uint8_t hitIndex,
                              const CreatureLib::Battling::ExecutingAttack::HitData& hitData) const override;
        float GetDamageModifier(CreatureLib::Battling::ExecutingAttack* attack, CreatureLib::Battling::Creature* target,
                                uint8_t hitIndex,
                                const CreatureLib::Battling::ExecutingAttack::HitData& hitData) const override;
    };
}

#endif // PKMNLIB_DAMAGELIBRARY_HPP
